import _defaults2 from 'lodash/defaults';
import _defaults from 'lodash/defaults';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

import * as React from 'react';

import { connect } from 'react-redux';
import { createStructuredSelector, createSelector } from 'reselect';

export default function featureComponents(options) {
  const { getFeatures, sortFeatures, getComponents } = _defaults2({}, options, {
    getFeatures: state => state ? state.features : {},
    sortFeatures: features => Object.values(features)
  });

  const mapStateToProps = createStructuredSelector({
    features: createSelector(getFeatures, sortFeatures)
  });

  function mergeProps({ features }, dispatchProps, _ref) {
    let { children } = _ref,
        props = _objectWithoutProperties(_ref, ['children']);

    const renderedComponents = [];
    features.forEach((feature, featureIndex) => {
      let components = getComponents(feature);
      if (components == null) return;
      if (!Array.isArray(components)) components = [components];
      components.forEach((Comp, index) => {
        const key = featureIndex + ':' + index;
        if (React.isValidElement(Comp)) renderedComponents.push(React.cloneElement(Comp, _extends({}, props, { key })));else if (typeof Comp === 'function') renderedComponents.push(React.createElement(Comp, _extends({}, props, { key: key })));
      });
    });
    return {
      children: children instanceof Function ? children(renderedComponents) : React.createElement(
        'div',
        null,
        renderedComponents
      )
    };
  }

  const FeatureComponents = ({ children }) => children;

  return connect(mapStateToProps, null, mergeProps)(FeatureComponents);
}